/* -*- buffer-read-only: t -*- vi: set ro:
   THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT.
*/
#define MF_SOURCE_NAME  MF_SOURCE_BI_DB
#ifdef HAVE_CONFIG_H
# include <config.h>
#endif
#include <sys/types.h>
#include "mailfromd.h"
#include "prog.h"
#include "builtin.h"

#line 1 "bi_db.m4"
/* This file is part of Mailfromd.             -*- c -*-
   Copyright (C) 2006, 2007, 2008 Sergey Poznyakoff

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#define LOOKUP_NULL_BYTE 0x1
#define LOOKUP_TEST_ONLY 0x2

static int
dbmap_lookup(eval_environ_t env, char *dbname, const char *keystr,
	     const char *defval, int flags)
{
	int rc;
	DBM_FILE db;
	DBM_DATUM key;
	DBM_DATUM contents;

	if (!defval)
		defval = "";
	if (mu_dbm_open(dbname, &db, MU_STREAM_READ, 0, NULL))
			env_throw_bi(env, mfe_dbfailure, NULL, _("mu_dbm_open(%s) failed: %s"),dbname,mu_dbm_strerror());
#line 36

	memset(&key, 0, sizeof key);
	memset(&contents, 0, sizeof contents);
	MU_DATUM_PTR(key) = (void*) keystr;
	MU_DATUM_SIZE(key) = strlen(keystr);
	if (flags & LOOKUP_NULL_BYTE)
		MU_DATUM_SIZE(key)++;
	rc = mu_dbm_fetch(&db, key, &contents) == 0;
	debug2(10, "Looking up %s: %s", keystr, rc ? "true" : "false");
	if (flags & LOOKUP_TEST_ONLY) 
		push(env, (STKVAL)rc);
	else {
		if (!rc) {
			if (defval)
				pushs(env, (STKVAL)defval);
			else
				push(env, 0);
		} else if (((char*)MU_DATUM_PTR(contents))[MU_DATUM_SIZE(contents)-1]) {
			size_t off;
			size_t len = MU_DATUM_SIZE(contents);
			char *s = (char*) env_data_ref(env, (off = heap_reserve(env, len + 1)));
			memcpy(s, MU_DATUM_PTR(contents), len);
			s[len] = 0;
			push(env, (STKVAL) off);
		} else
			pushs(env, MU_DATUM_PTR(contents));
	}
	mu_dbm_datum_free(&contents);
	mu_dbm_close(&db);
	return rc;
}

void
#line 68
bi_dbmap(eval_environ_t env)
#line 68

#line 68 "bi_db.m4"
{
#line 68
	
#line 68

#line 68
long __bi_argcnt;
#line 68
char * dbname;
#line 68
        char * key;
#line 68
        long  null;
#line 68
        
#line 68
get_string_arg(env, 1, &dbname);
#line 68
        get_string_arg(env, 2, &key);
#line 68
        get_numeric_arg(env, 3, &null);
#line 68
        
#line 68
get_numeric_arg(env, 0, &__bi_argcnt);
#line 68
        adjust_stack(env, __bi_argcnt + 1);
#line 68

#line 68
	if (prog_trace_option & BUILTIN_MASK_db)
#line 68
		prog_trace(env, "dbmap %s %s %lu",dbname, key, ((__bi_argcnt > 2) ? null : 0));;
#line 68

{
	dbmap_lookup(env, dbname, key, NULL,
		     LOOKUP_TEST_ONLY | 
                        (((__bi_argcnt > 2) ? null : 0) ? LOOKUP_NULL_BYTE : 0));
}
}

void
#line 76
bi_dbget(eval_environ_t env)
#line 76

#line 76 "bi_db.m4"
{
#line 76
	
#line 76

#line 76
long __bi_argcnt;
#line 76
char * dbname;
#line 76
        char * key;
#line 76
        char * defval;
#line 76
        long  null;
#line 76
        
#line 76
get_string_arg(env, 1, &dbname);
#line 76
        get_string_arg(env, 2, &key);
#line 76
        get_string_arg(env, 3, &defval);
#line 76
        get_numeric_arg(env, 4, &null);
#line 76
        
#line 76
get_numeric_arg(env, 0, &__bi_argcnt);
#line 76
        adjust_stack(env, __bi_argcnt + 1);
#line 76

#line 76
	if (prog_trace_option & BUILTIN_MASK_db)
#line 76
		prog_trace(env, "dbget %s %s %s %lu",dbname, key, ((__bi_argcnt > 2) ? defval : ""), ((__bi_argcnt > 3) ? null : 0));;

{
	dbmap_lookup(env, dbname, key, 
                     ((__bi_argcnt > 2) ? defval : 0), 
                     (((__bi_argcnt > 3) ? null : 0) ? LOOKUP_NULL_BYTE : 0));
}
}

void
#line 85
bi_dbput(eval_environ_t env)
#line 85

#line 85 "bi_db.m4"
{
#line 85
	
#line 85

#line 85
long __bi_argcnt;
#line 85
char * dbname;
#line 85
        char * keystr;
#line 85
        char * value;
#line 85
        long  null;
#line 85
        
#line 85
get_string_arg(env, 1, &dbname);
#line 85
        get_string_arg(env, 2, &keystr);
#line 85
        get_string_arg(env, 3, &value);
#line 85
        get_numeric_arg(env, 4, &null);
#line 85
        
#line 85
get_numeric_arg(env, 0, &__bi_argcnt);
#line 85
        adjust_stack(env, __bi_argcnt + 1);
#line 85

#line 85
	if (prog_trace_option & BUILTIN_MASK_db)
#line 85
		prog_trace(env, "dbput %s %s %s %lu",dbname, keystr, value, ((__bi_argcnt > 3) ? null : 0));;

{
	int rc;
	DBM_FILE db;
	DBM_DATUM key;
	DBM_DATUM contents;
	
	if (mu_dbm_open(dbname, &db, MU_STREAM_RDWR, 0640, NULL))
			env_throw_bi(env, mfe_dbfailure, "dbput", _("mu_dbm_open(%s) failed: %s"),dbname,mu_dbm_strerror());
#line 98
	memset(&key, 0, sizeof key);
	MU_DATUM_PTR(key) = keystr;
	MU_DATUM_SIZE(key) = strlen(keystr);
	if (((__bi_argcnt > 3) ? null : 0))
		MU_DATUM_SIZE(key)++;

	memset(&contents, 0, sizeof contents);
	MU_DATUM_PTR(contents) = value;
	MU_DATUM_SIZE(contents) = strlen(value) + 1;
	
	rc = mu_dbm_insert(&db, key, contents, 1);
	mu_dbm_close(&db);
		if (!(rc == 0))
#line 110
			env_throw_bi(env, mfe_dbfailure, "dbput", _("Failed to insert data to %s: %s %s: %s"),dbname,keystr,value,mu_dbm_strerror())
#line 116
;
}
}

void
#line 120
bi_dbdel(eval_environ_t env)
#line 120

#line 120 "bi_db.m4"
{
#line 120
	
#line 120

#line 120
long __bi_argcnt;
#line 120
char * dbname;
#line 120
        char * keystr;
#line 120
        long  null;
#line 120
        
#line 120
get_string_arg(env, 1, &dbname);
#line 120
        get_string_arg(env, 2, &keystr);
#line 120
        get_numeric_arg(env, 3, &null);
#line 120
        
#line 120
get_numeric_arg(env, 0, &__bi_argcnt);
#line 120
        adjust_stack(env, __bi_argcnt + 1);
#line 120

#line 120
	if (prog_trace_option & BUILTIN_MASK_db)
#line 120
		prog_trace(env, "dbdel %s %s %lu",dbname, keystr, ((__bi_argcnt > 2) ? null : 0));;
#line 120

{
	DBM_FILE db;
	DBM_DATUM key;
	int rc;	
	if (mu_dbm_open(dbname, &db, MU_STREAM_RDWR, 0640, NULL))
			env_throw_bi(env, mfe_dbfailure, "dbdel", _("mu_dbm_open(%s) failed: %s"),dbname,mu_dbm_strerror());
#line 130
	memset(&key, 0, sizeof key);
	MU_DATUM_PTR(key) = keystr;
	MU_DATUM_SIZE(key) = strlen(keystr);
	if (((__bi_argcnt > 2) ? null : 0))
		MU_DATUM_SIZE(key)++;
	rc = mu_dbm_delete(&db, key);
	mu_dbm_close(&db);
		if (!(rc == 0))
#line 137
			env_throw_bi(env, mfe_dbfailure, "dbdel", _("Failed to delete data `%s' from `%s': %s"),keystr,dbname,mu_dbm_strerror())
#line 142
;
}
}


#define NUMDB 128

struct db_tab {
	int used;
	DBM_FILE db;
	DBM_DATUM key;
};

static void *
alloc_db_tab()
{
	return xcalloc(NUMDB, sizeof(struct db_tab));
}

static void
close_db_tab(struct db_tab *dbt)
{
	if (dbt->used) {
		mu_dbm_datum_free(&dbt->key);
		mu_dbm_close(&dbt->db);
		dbt->used = 0;
	}
}

static void
destroy_db_tab(void *data)
{
	int i;
	struct db_tab *db = data;
	for (i = 0; i < NUMDB; i++) 
		close_db_tab(db + i);
	free(db);
}


#line 181

#line 181
static int DBTAB_id;
#line 181 "bi_db.m4"
;

static int
new_db_tab(struct db_tab *dbt)
{
	int i;
	for (i = 0; i < NUMDB; i++)
		if (!dbt[i].used) {
			dbt[i].used = 1;
			return i;
		}
	return -1;
}
			


void
#line 197
bi_dbfirst(eval_environ_t env)
#line 197

#line 197 "bi_db.m4"
{
#line 197
	
#line 197

#line 197

#line 197
char * dbname;
#line 197
        
#line 197
get_string_arg(env, 0, &dbname);
#line 197
        
#line 197

#line 197
        adjust_stack(env, 1);
#line 197

#line 197
	if (prog_trace_option & BUILTIN_MASK_db)
#line 197
		prog_trace(env, "dbfirst %s",dbname);;
#line 197

{
	int rc;
	int n;
	struct db_tab *dbt = env_get_builtin_priv(env,DBTAB_id);
	DBM_FILE db;
	DBM_DATUM key;
	
	if (mu_dbm_open(dbname, &db, MU_STREAM_RDWR, 0640, NULL))
			env_throw_bi(env, mfe_dbfailure, "dbfirst", _("mu_dbm_open(%s) failed: %s"),dbname,mu_dbm_strerror());
#line 210
	rc = mu_dbm_firstkey(&db, &key);
		if (!(rc == 0))
#line 211
			env_throw_bi(env, mfe_dbfailure, "dbfirst", _("mu_dbm_firstkey failed: %s"),mu_dbm_strerror())
#line 213
;
	n = new_db_tab(dbt);
		if (!(n >= 0))
#line 215
			env_throw_bi(env, mfe_failure, "dbfirst", _("No more database entries available"))
#line 217
;
	dbt += n;
	dbt->db = db;
	dbt->key = key;
	
#line 221
do {
#line 221
  push(env, (STKVAL) (n));
#line 221
  return;
#line 221
} while (0);
}
}

void
#line 225
bi_dbnext(eval_environ_t env)
#line 225

#line 225 "bi_db.m4"
{
#line 225
	
#line 225

#line 225

#line 225
long  dn;
#line 225
        
#line 225
get_numeric_arg(env, 0, &dn);
#line 225
        
#line 225

#line 225
        adjust_stack(env, 1);
#line 225

#line 225
	if (prog_trace_option & BUILTIN_MASK_db)
#line 225
		prog_trace(env, "dbnext %lu",dn);;
#line 225

{
	struct db_tab *dbt = env_get_builtin_priv(env,DBTAB_id) + dn;
	DBM_DATUM nextkey;
	int rc;
	
		if (!(dn >= 0 && dn < NUMDB && dbt->used))
#line 231
			env_throw_bi(env, mfe_range, "dbnext", _("Invalid database descriptor"))
#line 233
;

	rc = mu_dbm_nextkey(&dbt->db, dbt->key, &nextkey);
	if (rc) {
		close_db_tab(dbt);
		
#line 238
do {
#line 238
  push(env, (STKVAL) (0));
#line 238
  return;
#line 238
} while (0);
	}
	mu_dbm_datum_free(&dbt->key);
	dbt->key = nextkey;
	
#line 242
do {
#line 242
  push(env, (STKVAL) (1));
#line 242
  return;
#line 242
} while (0);
}
}

void
#line 246
bi_dbkey(eval_environ_t env)
#line 246

#line 246 "bi_db.m4"
{
#line 246
	
#line 246

#line 246

#line 246
long  dn;
#line 246
        
#line 246
get_numeric_arg(env, 0, &dn);
#line 246
        
#line 246

#line 246
        adjust_stack(env, 1);
#line 246

#line 246
	if (prog_trace_option & BUILTIN_MASK_db)
#line 246
		prog_trace(env, "dbkey %lu",dn);;
#line 246

{
	size_t off, len;
	char *s;
	struct db_tab *dbt = env_get_builtin_priv(env,DBTAB_id) + dn;
	
		if (!(dn >= 0 && dn < NUMDB && dbt->used))
#line 252
			env_throw_bi(env, mfe_range, "dbkey", _("Invalid database descriptor"))
#line 254
;
	
	len = MU_DATUM_SIZE(dbt->key);
	s = (char*) env_data_ref(env, (off = heap_reserve(env, len + 1)));
	memcpy(s, MU_DATUM_PTR(dbt->key), len);
	s[len] = 0;
	
#line 260
do {
#line 260
  push(env, (STKVAL) (off));
#line 260
  return;
#line 260
} while (0);
}
}

void
#line 264
bi_dbvalue(eval_environ_t env)
#line 264

#line 264 "bi_db.m4"
{
#line 264
	
#line 264

#line 264

#line 264
long  dn;
#line 264
        
#line 264
get_numeric_arg(env, 0, &dn);
#line 264
        
#line 264

#line 264
        adjust_stack(env, 1);
#line 264

#line 264
	if (prog_trace_option & BUILTIN_MASK_db)
#line 264
		prog_trace(env, "dbvalue %lu",dn);;
#line 264

{
	int rc;
	size_t off, len;
	char *s;
	struct db_tab *dbt = env_get_builtin_priv(env,DBTAB_id) + dn;
	DBM_DATUM contents;
	
		if (!(dn >= 0 && dn < NUMDB && dbt->used))
#line 272
			env_throw_bi(env, mfe_range, "dbvalue", _("Invalid database descriptor"))
#line 274
;

	memset(&contents, 0, sizeof contents);
	rc = mu_dbm_fetch(&dbt->db, dbt->key, &contents);
		if (!(rc == 0))
#line 278
			env_throw_bi(env, mfe_dbfailure, "dbvalue", _("Key not found: %s"),mu_dbm_strerror())
#line 281
;
	
	len = MU_DATUM_SIZE(contents);
	s = (char*) env_data_ref(env, (off = heap_reserve(env, len + 1)));
	memcpy(s, MU_DATUM_PTR(contents), len);
	s[len] = 0;
	mu_dbm_datum_free(&contents);
	
#line 288
do {
#line 288
  push(env, (STKVAL) (off));
#line 288
  return;
#line 288
} while (0);
}
}


static void
greylist_print_item(const char *key, size_t size, const void *content)
{
	time_t timestamp = *(time_t*) content;
	size--; /* Size includes the trailing nul */
	printf("%*.*s ", size, size, key);
	format_time_str(stdout, timestamp);
	putchar('\n');
}

static int
greylist_expire_item(const void *content)
{
	time_t timestamp = *(time_t*) content;
	return greylist_format->expire_interval &&
		time(NULL) - timestamp > greylist_format->expire_interval;
}


static struct db_format greylist_format_struct = {
	"greylist",
	DEFAULT_GREYLIST_DATABASE,
	1,
	DEFAULT_EXPIRE_INTERVAL,
	greylist_print_item,
	greylist_expire_item
};

struct db_format *greylist_format = &greylist_format_struct;

static size_t greylist_seconds_left_loc
#line 323 "bi_db.m4"
;

/* greylist(key, interval)

   Returns true if the key is greylisted, false if it's OK to
   deliver mail.
 */
void
#line 330
bi_greylist(eval_environ_t env)
#line 330

#line 330 "bi_db.m4"
{
#line 330
	
#line 330

#line 330

#line 330
char * email;
#line 330
        long  interval;
#line 330
        
#line 330
get_string_arg(env, 0, &email);
#line 330
        get_numeric_arg(env, 1, &interval);
#line 330
        
#line 330

#line 330
        adjust_stack(env, 2);
#line 330

#line 330
	if (prog_trace_option & BUILTIN_MASK_db)
#line 330
		prog_trace(env, "greylist %s %lu",email, interval);;
#line 330

{
	int rc;
	DBM_FILE db;
	DBM_DATUM key;
	DBM_DATUM contents;
	int readonly;
	time_t now;

	rc = mu_dbm_open(greylist_format->dbname, &db, MU_STREAM_RDWR, 0600,
			 &readonly);
        	if (!(rc == 0))
#line 341
			env_throw_bi(env, mfe_dbfailure, "greylist", _("mu_dbm_open(%s) failed: %s"),greylist_format->dbname,mu_dbm_strerror())
;
	
	memset(&key, 0, sizeof key);
	memset(&contents, 0, sizeof contents);
	MU_DATUM_PTR(key) = email;
	MU_DATUM_SIZE(key) = strlen(email)+1;

	time(&now);
	if (mu_dbm_fetch(&db, key, &contents) == 0) {
		time_t timestamp, diff;

			if (!(MU_DATUM_SIZE(contents) == sizeof timestamp))
#line 353
			env_throw_bi(env, mfe_dbfailure, "greylist", _("Greylist database %s has wrong data size"),greylist_format->dbname)
#line 356
;
		
		timestamp = *(time_t*) MU_DATUM_PTR(contents);
		diff = now - timestamp;
	
		__DBG(20) {
			char timebuf[32];
			debug_log("%s entered greylist database on %s, "
				  "%ld seconds ago",
				  email,
				  mailfromd_timestr(timestamp, timebuf,
						    sizeof timebuf),
				  (long) diff);
		}

		if (diff < interval) {
			diff = interval - diff;

			*env_data_ref(env, greylist_seconds_left_loc) = (STKVAL) (diff);
			
			debug2(20, "%s still greylisted (for %lu sec.)",
			       email,
			       (unsigned long) diff);
			rc = 1;
		} else if (diff > greylist_format->expire_interval) {
			debug1(20, "greylist record for %s expired",
			       email);
			if (!readonly) {
				memcpy(MU_DATUM_PTR(contents),
				       &now, sizeof now);
				if (mu_dbm_insert(&db, key, contents, 1))
					mu_error(_("Cannot insert datum `%-.*s' in "
						   "greylist database %s: %s"),
			                         MU_DATUM_SIZE(key),
						 (char*)MU_DATUM_PTR(key),
						 greylist_format->dbname,
	                                         mu_dbm_strerror());
			} else
				debug(20, "database opened in readonly mode: "
				      "not updating");
			rc = 1;
		} else {
			debug1(20, "%s finished greylisting period",
			       email);
			rc = 0;
		}
		mu_dbm_datum_free(&contents);
	} else if (!readonly) {
		debug1(20, "greylisting %s", email);
		*env_data_ref(env, greylist_seconds_left_loc) = (STKVAL) (interval);
		MU_DATUM_PTR(contents) = (void*)&now;
		MU_DATUM_SIZE(contents) = sizeof now;
		if (mu_dbm_insert(&db, key, contents, 1))
			mu_error(_("Cannot insert datum `%-.*s' in greylist "
				   "database %s: %s"),
		                 MU_DATUM_SIZE(key), (char*)MU_DATUM_PTR(key),
				 greylist_format->dbname,
	                         mu_dbm_strerror());
		rc = 1;
	} else
		rc = 0;

	mu_dbm_close(&db);

	
#line 420
do {
#line 420
  push(env, (STKVAL) (rc));
#line 420
  return;
#line 420
} while (0);
}
}

void
#line 424
bi_db_name(eval_environ_t env)
#line 424

#line 424 "bi_db.m4"
{
#line 424
	
#line 424

#line 424

#line 424
char * fmtid;
#line 424
        
#line 424
get_string_arg(env, 0, &fmtid);
#line 424
        
#line 424

#line 424
        adjust_stack(env, 1);
#line 424

#line 424
	if (prog_trace_option & BUILTIN_MASK_db)
#line 424
		prog_trace(env, "db_name %s",fmtid);;
#line 424

{
	struct db_format *fmt = db_format_lookup(fmtid);
		if (!(fmt != NULL))
#line 427
			env_throw_bi(env, mfe_not_found, "db_name", _("No such db format: %s"),fmtid)
#line 429
;
	do {pushs(env, fmt->dbname);
#line 430
return;
#line 430
} while (0);
}
}

void
#line 434
bi_db_get_active(eval_environ_t env)
#line 434

#line 434 "bi_db.m4"
{
#line 434
	
#line 434

#line 434

#line 434
char * fmtid;
#line 434
        
#line 434
get_string_arg(env, 0, &fmtid);
#line 434
        
#line 434

#line 434
        adjust_stack(env, 1);
#line 434

#line 434
	if (prog_trace_option & BUILTIN_MASK_db)
#line 434
		prog_trace(env, "db_get_active %s",fmtid);;
#line 434

{
	struct db_format *fmt = db_format_lookup(fmtid);
		if (!(fmt != NULL))
#line 437
			env_throw_bi(env, mfe_not_found, "db_get_active", _("No such db format: %s"),fmtid)
#line 439
;
	
#line 440
do {
#line 440
  push(env, (STKVAL) (fmt->enabled));
#line 440
  return;
#line 440
} while (0);
}
}

void
#line 444
bi_db_set_active(eval_environ_t env)
#line 444

#line 444 "bi_db.m4"
{
#line 444
	
#line 444

#line 444

#line 444
char * fmtid;
#line 444
        long  active;
#line 444
        
#line 444
get_string_arg(env, 0, &fmtid);
#line 444
        get_numeric_arg(env, 1, &active);
#line 444
        
#line 444

#line 444
        adjust_stack(env, 2);
#line 444

#line 444
	if (prog_trace_option & BUILTIN_MASK_db)
#line 444
		prog_trace(env, "db_set_active %s %lu",fmtid, active);;
#line 444

{
	struct db_format *fmt = db_format_lookup(fmtid);
		if (!(fmt != NULL))
#line 447
			env_throw_bi(env, mfe_not_found, "db_set_active", _("No such db format: %s"),fmtid)
#line 449
;
	fmt->enabled = active;
}
}

void
#line 454
bi_db_expire_interval(eval_environ_t env)
#line 454

#line 454 "bi_db.m4"
{
#line 454
	
#line 454

#line 454

#line 454
char * fmtid;
#line 454
        
#line 454
get_string_arg(env, 0, &fmtid);
#line 454
        
#line 454

#line 454
        adjust_stack(env, 1);
#line 454

#line 454
	if (prog_trace_option & BUILTIN_MASK_db)
#line 454
		prog_trace(env, "db_expire_interval %s",fmtid);;
#line 454

{
	struct db_format *fmt = db_format_lookup(fmtid);
		if (!(fmt != NULL))
#line 457
			env_throw_bi(env, mfe_not_found, "db_expire_interval", _("No such db format: %s"),fmtid)
#line 459
;
	
#line 460
do {
#line 460
  push(env, (STKVAL) (fmt->expire_interval));
#line 460
  return;
#line 460
} while (0);
}
}


#line 464
void
#line 464
db_init_builtin()
#line 464
{
#line 464
	#line 68 "bi_db.m4"
va_builtin_install_ex("dbmap", bi_dbmap, 0, 0, dtype_number, 3, 1, 0, dtype_string, dtype_string, dtype_number);
#line 76 "bi_db.m4"
va_builtin_install_ex("dbget", bi_dbget, 0, 0, dtype_string, 4, 2, 0, dtype_string, dtype_string, dtype_string, dtype_number);
#line 85 "bi_db.m4"
va_builtin_install_ex("dbput", bi_dbput, 0, 0, dtype_unspecified, 4, 1, 0, dtype_string, dtype_string, dtype_string, dtype_number);
#line 120 "bi_db.m4"
va_builtin_install_ex("dbdel", bi_dbdel, 0, 0, dtype_unspecified, 3, 1, 0, dtype_string, dtype_string, dtype_number);
#line 181 "bi_db.m4"
DBTAB_id = builtin_priv_register(alloc_db_tab, destroy_db_tab);
#line 197 "bi_db.m4"
va_builtin_install_ex("dbfirst", bi_dbfirst, 0, 0, dtype_number, 1, 0, 0, dtype_string);
#line 225 "bi_db.m4"
va_builtin_install_ex("dbnext", bi_dbnext, 0, 0, dtype_number, 1, 0, 0, dtype_number);
#line 246 "bi_db.m4"
va_builtin_install_ex("dbkey", bi_dbkey, 0, 0, dtype_string, 1, 0, 0, dtype_number);
#line 264 "bi_db.m4"
va_builtin_install_ex("dbvalue", bi_dbvalue, 0, 0, dtype_string, 1, 0, 0, dtype_number);
#line 323 "bi_db.m4"
	greylist_seconds_left_loc = builtin_variable_install("greylist_seconds_left", dtype_number, VAR_VOLATILE)->off;
#line 330 "bi_db.m4"
va_builtin_install_ex("greylist", bi_greylist, 0, 0, dtype_number, 2, 0, 0, dtype_string, dtype_number);
#line 424 "bi_db.m4"
va_builtin_install_ex("db_name", bi_db_name, 0, 0, dtype_string, 1, 0, 0, dtype_string);
#line 434 "bi_db.m4"
va_builtin_install_ex("db_get_active", bi_db_get_active, 0, 0, dtype_number, 1, 0, 0, dtype_string);
#line 444 "bi_db.m4"
va_builtin_install_ex("db_set_active", bi_db_set_active, 0, 0, dtype_unspecified, 2, 0, 0, dtype_string, dtype_number);
#line 454 "bi_db.m4"
va_builtin_install_ex("db_expire_interval", bi_db_expire_interval, 0, 0, dtype_number, 1, 0, 0, dtype_string);

#line 464 "bi_db.m4"
		
#line 464
}

#line 584 "../mfd/snarf.m4"

#line 584

